using Microsoft.Owin;
using Owin;
using System.Reflection;
using System.Web.Routing;
using GrapeCity.ActiveReports.Aspnet.Viewer;
using System;
using GrapeCity.ActiveReports;
using System.IO;
using GrapeCity.ActiveReports.Aspnetcore.Viewer;
using System.ComponentModel;
using System.Data.OleDb;
using System.Data;
using System.Text;

[assembly: OwinStartup(typeof(prj_MasterDetailReport.Startup))]

namespace prj_MasterDetailReport
{
    public class Startup
    {
        public static string EmbeddedReportsPrefix = "prj_MasterDetailReport.Reports";

        public void Configuration(IAppBuilder app)
        {
            
            app.UseReporting(settings =>
            {
                //Customise the reporting service
                settings.UseCustomStore(GetReport);
                settings.UseCompression = true;
            });

            RouteTable.Routes.RouteExistingFiles = true;
        }
        string baseDirectory = "";
        private object GetReport(string arg)
        {
            baseDirectory = AppDomain.CurrentDomain.BaseDirectory + "\\Reports\\";
            string reportPath = baseDirectory + arg;
            //Load Content Report from the database
            var stream = new MemoryStream(GetContentReport());
            var resourceLocator = new MasterReportResourceLocator();
            if (stream == null)
                throw new ReportNotFoundException();
            using (var reader = new StreamReader(stream))
            {
                var report = GrapeCity.ActiveReports.Rdl.Persistence.PersistenceFilter.Load(reader, resourceLocator);
                 report.Site = new ReportSite(resourceLocator);
                if (string.IsNullOrEmpty(report.Name))
                    report.Name = arg;
                report.DataSources[0].ConnectionProperties.ConnectString = String.Format("provider=Microsoft.Jet.OLEDB.4.0;data source={0}MasterData.mdb;", baseDirectory);
                return report;
            }

                
        }
        private byte[] GetContentReport()
        {
            string connetionString = null;
            OleDbConnection oledbCnn;
            OleDbDataAdapter oledbAdapter;
            DataTable ds = new DataTable();
            string sql = null;

            connetionString = String.Format(@"Provider=Microsoft.Jet.OLEDB.4.0;Data Source={0}Reports\MasterData.mdb;", AppDomain.CurrentDomain.BaseDirectory);
            sql = " Select * from ContentReportTable";
            byte[] byteArray;
            oledbCnn = new OleDbConnection(connetionString);

            oledbCnn.Open();
            oledbAdapter = new OleDbDataAdapter(sql, oledbCnn);
            oledbAdapter.Fill(ds);
            byteArray = Encoding.ASCII.GetBytes(ds.Rows[0].ItemArray[0].ToString());
            oledbAdapter.Dispose();
            oledbCnn.Close();


            return byteArray;
        }
    }
    public class ReportSite : ISite
    {
        private readonly ResourceLocator _resourceLocator;

        public ReportSite(ResourceLocator resourceLocator)
        {
            _resourceLocator = resourceLocator;
        }

        public object GetService(Type serviceType) =>
            serviceType == typeof(ResourceLocator) ? _resourceLocator : null;

        public IComponent Component => null;
        public IContainer Container => null;
        public bool DesignMode => false;
        public string Name { get; set; }
    }

    public class MasterReportResourceLocator : ResourceLocator
    {
        public override Resource GetResource(ResourceInfo resourceInfo)
        {
            Resource _resource ;
           
            if (resourceInfo.Name.Equals("Master.rdlx-master"))
            {
                
                var stream = new MemoryStream(GetMasterReport());
                if (stream != null)
                {
                   
                    _resource = new Resource(stream, null );
                }
            }
            return _resource;
        }

        private byte[] GetMasterReport()
        {
            string connetionString = null;
            OleDbConnection oledbCnn;
            OleDbDataAdapter oledbAdapter;
            DataTable ds = new DataTable();
            string sql = null;

            connetionString = String.Format(@"Provider=Microsoft.Jet.OLEDB.4.0;Data Source={0}Reports\MasterData.mdb;",AppDomain.CurrentDomain.BaseDirectory);
            sql = " Select * from MasterReportTable";
            byte[] byteArray;
            oledbCnn = new OleDbConnection(connetionString);
         
                oledbCnn.Open();
                oledbAdapter = new OleDbDataAdapter(sql, oledbCnn);
                oledbAdapter.Fill(ds);
                byteArray = Encoding.ASCII.GetBytes(ds.Rows[0].ItemArray[0].ToString());
                oledbAdapter.Dispose();
                oledbCnn.Close();
            

            return byteArray;
        }
    }
}